(function ($) {
Drupal.behaviors.routeplanner = function (context) {
  if (!Drupal.myRoutePlanner) {
    Drupal.myRoutePlanner = new Drupal.RoutePlanner();
  }
};

Drupal.RoutePlanner = function() {
  this.directionsService = new google.maps.DirectionsService();
  this.map = null;

  // initialize the map
  this.route();
}

Drupal.RoutePlanner.prototype.route = function(){
  directionsDisplay = new google.maps.DirectionsRenderer();
  geocoder = new google.maps.Geocoder();
  var latLng;
  if (geocoder) {
    geocoder.geocode( { "address": Drupal.settings.routePlanner['end']}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
         latLng = new String(results[0].geometry.location);
         latLng = latLng.substr(1, (latLng.length-2) );
         latLng = latLng.split(",");
         var location = new google.maps.LatLng(latLng[0], latLng[1]);

       var myOptions = {
         zoom: Drupal.settings.routePlanner['zoomlevel'],
         mapTypeId: google.maps.MapTypeId.ROADMAP,
         center: location
       }
         this.map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
         var marker = new google.maps.Marker({
           map: this.map,
           position: results[0].geometry.location
         });
         directionsDisplay.setMap(this.map);
      } else {
        alert(Drupal.t("Geocode was not successful for the following reason: ") + status);
      }
    });
  }
  return false;
}

Drupal.RoutePlanner.prototype.calcRoute = function(){
  var start = document.getElementById("edit-start").value;
  var request = {
      origin:start,
      destination: Drupal.settings.routePlanner['end'],
      travelMode: google.maps.DirectionsTravelMode.DRIVING
  };
  this.directionsService.route(request, function(response, status) {
    if (status == google.maps.DirectionsStatus.OK) {
      this.directionsDisplay.setDirections(response);
      distance = response.routes[0].legs[0].distance.text;
      time = response.routes[0].legs[0].duration.text;
      document.getElementById("edit-time").value = time;
      document.getElementById("edit-distance").value = distance;
    }
  });
  return false;
}

})(jQuery);